# winfuture.tcl v1.2 by domsen <domsen@domsen.org> (c)2oo4
#
# comments? bugs? ideas? requests? money? beer? 
# plz mail me or visit my homepage @ www.domsen.org
# visit #newsticker@ircnet
#
# das tcl  liest  die www.winfuture.de  news aus  und gibt  sie wieder,  gleich mit
# dem link zum eigentlichen artikel. per trigger lassen sich auch die letzten X
# news von hand auslesen.
#
# v1.2 - script ging wohl nicht mehr :)
# v1.1 - first public release
#
# winfuturetrigger - der trigger auf den der bot reagiert (public und message)
# winfuturelimit - maximum der news die auf befehl geposted werden
# winfuturenewspost  - 1 fr newsposting, 0 fr keines
# winfuturechans  - die  chans in  denen das tcl aktiv  ist, "" fr alle
# winfuturenewspostlimit - maximum der news die geposted werden
# iswinfuturehub  - legt fest ob der bot newshub ist oder nicht
# winfutureleafs  - die nicks der leafbots auf denen das leaf tcl luft
#
####### config ######################

set winfuturetrigger ".winfuture"
set winfuturechans ""
set winfuturelimit "10"
set winfuturenewspostlimit "3"
set winfuturenewspost "1"
set iswinfuturehub "0"
set winfutureleafs ""

####### ende der config #############

bind msg - $winfuturetrigger msg_winfuture
bind pub - $winfuturetrigger pub_winfuture
bind time - "?0 * * * *" winfuturecheck

proc sendwinfuturenews { arg } {
global winfutureleafs
foreach bot [bots] {
if {([lsearch -exact [string tolower $winfutureleafs] [string tolower $bot]] != -1)} {
putbot $bot "winfuture: $arg"
}}}

proc shrink { calc number string start bl} { return [expr [string first "$string" $bl $start] $calc $number] }

proc html { text } {
regsub -all "&uuml;" $text "" text
regsub -all "&ouml;" $text "" text
regsub -all "&auml;" $text "" text
regsub -all "&Uuml;" $text "" text
regsub -all "&Ouml;" $text "" text
regsub -all "&Auml;" $text "" text
regsub -all "&szlig;" $text "" text
regsub -all "&quot;" $text "\"" text
regsub -all "&amp;" $text "&" text
regsub -all "<sub>" $text "" text
regsub -all "&lt;" $text "<" text
regsub -all "&gt;" $text ">" text
return $text
}

proc winfuturecheck {nick uhost hand chan arg} {
global winfuturechans winfuturenewspost iswinfuturehub winfuturenewspostlimit
set counter 0
if {$winfuturenewspost == 1 } {
putlog "winfuture: suche nach neuer newsline"
set winfuturelastnews "none"
if {[file exists winfuture.hdl]} {
set temp [open "winfuture.hdl" r]
set winfuturelastnews "[gets $temp]"
if {$winfuturelastnews == ""} { set winfuturelastnews "none" }
close $temp
}
set temp [open "winfuture.hdl" w+]
if {[catch {set sock [socket media-designs.de 80] } sockerror]} {
putlog "error: $sockerror"
return 0 } else {
puts $sock "GET /winfuture.rdf HTTP/1.1"
puts $sock "User-Agent: Mozilla/4.0 (compatible; MSIE 6.0; Windows NT 5.0)"
puts $sock "Host: media-designs.de"
puts $sock ""
flush $sock
set counter 0
while {[eof $sock] != 1} {
set bl [gets $sock]
if {[string first "<title>" $bl] != -1 && [string first "Das online" $bl] == -1 } { set newsline [string range $bl 7 [shrink - 1 "</" 0 $bl]]}
if {[string first "<link>" $bl] != -1 && [string first "news" $bl] != -1} { set link [string range $bl 6 [shrink - 1 </ 0 $bl]]
puts $temp "[html $newsline] <$link>"
}}}
close $sock ; close $temp
if {$winfuturelastnews == "none" } { putlog "winfuture: headlinefile created" ; return 0 }
set temp [open "winfuture.hdl" r]
while { [eof $temp] != 1 } {
set winfutureneunews [gets $temp]
if {($winfuturelastnews == $winfutureneunews) || ($counter == $winfuturenewspostlimit)} { close $temp;return 0 }
incr counter
foreach chan [channels] {
if {$winfuturechans == "" } { putserv "privmsg $chan :(neue winfuture newsline) $winfutureneunews" }
if {$winfuturechans != "" } {
if {([lsearch -exact [string tolower $winfuturechans] [string tolower $chan]] != -1) || ($winfuturechans == "")} {putserv "privmsg $chan :(neue winfuture newsline) $winfutureneunews"}
}
if { $iswinfuturehub == "1" } { sendwinfuturenews $winfutureneunews }
}}}}


proc winfuturenews {target limit} {
if {[catch {set sock [socket media-designs.de 80] } sockerror]} {
putlog "error: $sockerror"
return 0 } else {
puts $sock "GET /winfuture.rdf HTTP/1.1"
puts $sock "User-Agent: Mozilla/4.0 (compatible; MSIE 6.0; Windows NT 5.0)"
puts $sock "Host: media-designs.de"
puts $sock ""
flush $sock
set counter 0
while {[eof $sock] != 1} {
set bl [gets $sock]
if {[string first "<title>" $bl] != -1 && [string first "Das online" $bl] == -1 } { set newsline [string range $bl 7 [shrink - 1 "</" 0 $bl]]}
if {[string first "<link>" $bl] != -1 && [string first "news" $bl] != -1} { set link [string range $bl 6 [shrink - 1 </ 0 $bl]]
putserv "privmsg $target :[incr counter] [html $newsline] <$link>"
}
if {$counter == $limit} {close $sock ; return 0 }
}}}

proc msg_winfuture { nick uhost hand arg } { global winfuturelimit ; winfuturenews $nick $winfuturelimit }
proc pub_winfuture { nick uhost hand chan arg } { global winfuturechans winfuturelimit ; if {([lsearch -exact [string tolower $winfuturechans] [string tolower $chan]] != -1) || ($winfuturechans == "")} { winfuturenews $nick $winfuturelimit }}

putlog "*** winfuture.tcl v1.2 by domsen <domsen@domsen.org> succesfully loaded"

#[EOF]